#!/bin/sh
# $Id: t-archk-0.sh,v 1.16 2005/05/31 21:11:21 ca Exp $
# Copyright (c) 2003-2005 Sendmail, Inc. and its suppliers.
#	All rights reserved.
#
# By using this file, you agree to the terms and conditions set
# forth in the LICENSE file which can be found at the top level of
# the sendmail distribution.
#
# ------------------------------------------------------------
# Description:
# Script to test alias resolution to get rejections (or ok).
# Uses smar, t-smar-2, "aliases" map, t-mm, startsmar.sh
# ------------------------------------------------------------
#
test -s stop && exit 1
#

# path to programs
P=..
SD=`dirname $0`
SHELL=/bin/sh
OUT=archk-0.out
RES=archk-0.ip
OK=archk-0.ok
SOCK=qmsmar/qmsmar
PIDS=pids
ERRS=0
TPRG=./t-smar-2
ALI=aliases
AMAP=${ALI}.db
killit()
{
if test -s ${PIDS}
then
  # stop MTA components
  for i in `cat ${PIDS}`
  do
    kill ${i}
  done
fi
# ----------------
# thanks kids for not following the POSIX standard...
if test X"`uname`" = "XLinux"
then
  killall smar
fi
exit 1
}

# create map for smar
rm -f ${AMAP}
../libsmmap/t-mm <<EOF
ok:	ok
postmaster:	ok
temp:	error:451
perm5:	error:550
perm:	error:
error:	error:6
OpenBSD+ports: ok+openbsd_ports
EOF
if test $? -ne 0
then
  echo t-mm failed
  exit 1
fi

rm -f ${SOCK} ${PIDS}
trap killit 1 2 3
rm -f mt
# start SMAR (creates mt: local.dom is local!)
${SD}/startsmar.sh || exit 1
rm -f ${OUT} ${RES} ${OK}

# check output somehow...
${VALGRIND} ${TPRG} -VVV '<no@local.dom>' > ${OUT} 2>&1
grep '^status=' ${OUT} > ${RES}
cat > ${OK} <<EOF
status=550
EOF
if diff ${OK} ${RES}
then
  :
else
  ERRS=`expr ${ERRS} + 1 `
  test X"${STOPONERROR}" != X && killit
fi

${VALGRIND} ${TPRG} -VVV '<ok@b.d>' > ${OUT} 2>&1
grep '^status=' ${OUT} > ${RES}
cat > ${OK} <<EOF
status=0
EOF
if diff ${OK} ${RES}
then
  :
else
  ERRS=`expr ${ERRS} + 1 `
  test X"${STOPONERROR}" != X && killit
fi

${VALGRIND} ${TPRG} -VVV '<ok@local.dom>' '<postmaster@local.dom>' > ${OUT} 2>&1
grep '^status=' ${OUT} > ${RES}
cat > ${OK} <<EOF
status=0
status=0
EOF
if diff ${OK} ${RES}
then
  :
else
  ERRS=`expr ${ERRS} + 1 `
  test X"${STOPONERROR}" != X && killit
fi

${VALGRIND} ${TPRG} -VVV '<temp@local.dom>' '<perm@local.dom>' '<perm5@local.dom>' > ${OUT} 2>&1
grep '^status=' ${OUT} > ${RES}
cat > ${OK} <<EOF
status=450
status=550
status=550
EOF
if diff ${OK} ${RES}
then
  :
else
  ERRS=`expr ${ERRS} + 1 `
  test X"${STOPONERROR}" != X && killit
fi

${VALGRIND} ${TPRG} -VVV '<error@local.dom>' > ${OUT} 2>&1
grep '^status=' ${OUT} > ${RES}
cat > ${OK} <<EOF
status=550
EOF
if diff ${OK} ${RES}
then
  :
else
  ERRS=`expr ${ERRS} + 1 `
  test X"${STOPONERROR}" != X && killit
fi

${VALGRIND} ${TPRG} -VVV '<OpenBSD+ports@local.dom>' > ${OUT} 2>&1
grep '^status=' ${OUT} > ${RES}
cat > ${OK} <<EOF
status=0
EOF
if diff ${OK} ${RES}
then
  :
else
  ERRS=`expr ${ERRS} + 1 `
  test X"${STOPONERROR}" != X && killit
fi


# stop SMAR
for i in `cat ${PIDS}`
do
  kill ${i}
done
# ----------------
# thanks kids for not following the POSIX standard...
if test X"`uname`" = "XLinux"
then
  killall smar
fi

exit ${ERRS}
